# Avorion Script API Documentation

Home Functions Search
Search:

Hud Hud
Properties
buildingUIVisible
mailWindowVisible
mouseOverSecondaryWindow
notificationsVisible
playerTradeWindowVisible
playerWindowVisible
resourcesVisible
shieldBarSaturation
shipWindowVisible
tutorialActive
center
height
index
layer
localCenter
localPosition
localRect
lower
mouseOver
position
rect
size
tooltip
tooltipWidth
upper
visible
width
Member Functions
addMouseShowingWindow
createContainer
createWindow
displayHint
displayNotification
highlightScriptButton
setCursor
hide
isMouseOverAndUnobscured
show

# Hud : UIElement

This object is only available on the client.

function Hud()

Returns

A new instance of Hud

property bool buildingUIVisible | [read-only]

property bool mailWindowVisible | [read-only]

property bool mouseOverSecondaryWindow | [read-only]

property bool notificationsVisible |

property bool playerTradeWindowVisible | [read-only]

property bool playerWindowVisible | [read-only]

property bool resourcesVisible | [read-only]

property float shieldBarSaturation | [write-only]

property bool shipWindowVisible | [read-only]

property bool tutorialActive | [read-only]

property vec2 center |

property float height |

property int index | [read-only]

property int layer |

property vec2 localCenter | [read-only]

property vec2 localPosition | [read-only]

property Rect localRect | [read-only]

property vec2 lower |

property bool mouseOver | [read-only]

property vec2 position |

property Rect rect |

property vec2 size |

property var tooltip |

property int tooltipWidth | [write-only]

property vec2 upper |

property bool visible |

property float width |

function var addMouseShowingWindow(Window window)

Returns

nothing

function UIContainer createContainer(Rect rect)

function Window createWindow(Rect rect)

function var displayHint(string text, var... highlights)

Displays a prioritized hint with the given text. The hint won't have a 'Don't show again' field, and it will override all other hints while its active. Hint will be removed when no more objects can be highlighted (which will only happen in case of passing ids of entities that then are deleted or destroyed), or when it's overridden by another call to 'displayHint', or when the player clicks on the 'X', or when the script that did the call was deleted.

Parameters

text Text that will be shown in the hint. Passing "" will disable the hint.
highlights Objects that should be highlighted. Can be any number of vec3, Rect, ids (string, Uuid) or Entity. Passing 0 objects will disable the hint.

Returns

nothing

function var displayNotification(string text, Color textColor, string icon, Color [or nil] iconColor, var alliance, var size, var iconPadding)

Displays a notification on the right hand side, similar to warnings or error messages.

Parameters

text The text of the notifiction
textColor Color of the text
icon Path to the icon that should be shown
iconColor Color of the icon
alliance If the notification is meant for the alliance (will show a small alliance banner next to the icon)
size Height of the notification in pixels
iconPadding Padding around the icon image (in percent from 0 to 1)

Returns

nothing

function var highlightScriptButton(string script)

Returns

nothing

function var setCursor(var icon, var x, var y)

Changes the cursor to another cursor. You should be very careful using this function and make sure that the cursor is always returned to what it was before once you don't need a special one any more. Passing nil as icon path will reset the cursor to default.

Parameters

icon path to the icon that should be used as the cursor
x X coordinate in pixels of the center of the cursor in the icon
y Y coordinate in pixels of the center of the cursor in the icon

Returns

nothing

function var hide()

Inherited from UIElement

Returns

nothing

function bool isMouseOverAndUnobscured()

Inherited from UIElement

function var show()

Inherited from UIElement

Returns

nothing

Overview
Home Functions Search
Search:
Callbacks
Callbacks Alliance [Client] Callbacks Alliance [Server] Callbacks Alliance [Server] Callbacks Entity Callbacks Galaxy Callbacks Player Callbacks Player [Client] Callbacks Sector Callbacks Server Callbacks
Predefined Functions & Example Scripts
Command Entity FactionDatabase PlanGenerator Player Sector Server UsableInventoryItem
Common Components
Boarding BspTree CargoBay CargoLoot ControlUnit CrewComponent DeletionTimer DirectFlightPhysics DockingClamps DockingParent DockingPositions Durability EnergySystem Engine FighterAI Hangar HyperspaceEngine InteractionText InventoryItemLoot Owner Physics Plan ReadOnlyBoarding ReadOnlyBspTree ReadOnlyCargoBay ReadOnlyControlUnit ReadOnlyCrew ReadOnlyDeletionTimer ReadOnlyEnergySystem ReadOnlyEngine ReadOnlyFighterAI ReadOnlyHangar ReadOnlyHyperspaceEngine ReadOnlyInteractionText ReadOnlyOwner ReadOnlyPhysics ReadOnlyPlan ReadOnlyShipAI ReadOnlyShipSystem ReadOnlyTorpedoAI [Server] [Client] [Server] [Client] ReadOnlyTorpedoAI [Server] [Client] [Server] [Client] ReadOnlyTorpedoLauncher ReadOnlyTurretBases ReadOnlyVelocity ReadOnlyWeapons ReadOnlyWormHole Shield ShipAI ShipSystem StructuralIntegrity SystemUpgradeLoot Thrusters Torpedo TorpedoAI TorpedoLauncher Turret TurretAI TurretBases Velocity Weapons WormHole
Common Objects
AllianceMember AllianceRank BlockPlan BlockPlanBlock BlockStatistics Box Captain Color ControlUnitSeat CraftDesign CraftStatsOverview Crew CrewMan CrewProfession DebugInfo dvec2 dvec3 dvec4 Entity EntityDescriptor FighterTemplate Format GameSettings Group HighResolutionTimer Inventory InventoryTurret ivec2 ivec3 ivec4 Language Mail Material Matrix ModManager NamedFormat PlanBspTree PlanetSpecifics PlanGenerationStage PlanPart PlanStyle PlayerId PluralForm Profiler QuadTree Random Rarity Ray ReadOnlyEntity Rect Relation Scenario SectorView Seed Sphere Squad SystemUpgradeTemplate Timer Tooltip TooltipLine TorpedoShaft TorpedoTemplate TradingGood TurretDesign TurretDesignPart TurretTemplate UsableInventoryItem Uuid VanillaInventoryItem vec2 vec3 vec4 Version Weapon
Client Components
EntityIcon EntityTooltip PlanMesh ReadOnlyIcon ReadOnlyPlanMesh ReadOnlyScriptUI ReadOnlyTooltip ScriptUI
Client Objects
Achievements Alliance [Client] CameraKeyFrame CaptainSelectionItem Client ClientSettings ColorSelectionItem CraftDesignSelectionItem Faction [Client] Galaxy [Client] GalaxyMap GameInput GlowFX IconSelectionItem InputWindow InventoryReferenceSelectionItem InventorySelectionItem Keyboard LaserFX Mouse Music PixelIconSelectionItem Planet Player [Client] PlayerWindow RefractionFX Sector [Client] SelectionItem ShipDatabaseEntry [Client] SoundSource StrategyState TargetIndicator TooltipRenderer TurretDesignSelectionItem
Client UI Objects
AllianceEmblem AllianceTab ArrowLine Button [Client] [Client] Button [Client] [Client] CaptainIcon CaptainProfile CheckBox ComboBox ContextMenu CraftPortrait CrewBar Frame Hud InventorySelection Label Line ListBox ListBoxEx MapArrowLine MapIcon MultiLineTextBox NumbersBar Picture PlanDisplayer ProgressBar SavedDesignsSelection ScrollFrame Selection ShipWindow Slider StatisticsBar Tab TabbedWindow TextBox TextField TooltipDisplayer Tree UIArbitraryHorizontalSplitter UIArbitraryVerticalSplitter UIContainer UIElement UIGridSplitter UIHorizontalLister UIHorizontalMultiSplitter UIHorizontalSplitter UIOrganizer UIRect UIRenderer UIVerticalLister UIVerticalMultiSplitter UIVerticalSplitter ValueComboBox Window
Server Components
EntityTransferrer FighterController Loot ReadOnlyEntityTransferrer ReadOnlyFighterController ReadOnlyLoot ReadOnlyTurretController ReadOnlyWreckageCreator TurretController WreckageCreator
Server Objects
Alliance [Server] Faction [Server] Galaxy [Server] Player [Server] ReadOnlySector Sector [Server] Server ShipDatabaseEntry [Server]
Enums
AIState AlliancePrivilege BeamShape BlockShading BlockStructure BlockType BlockType2 BoxType BuildError CaptainGenderId ChatChannel ChatMessageType ComponentType ControlAction ControlActionBit ControlStyle CoolingType CraftStatsOverviewStat CrewProfessionType CrewRank DamageSource DamageType DeletionType Difficulty EntityArrivalType EntityType FighterOrders FighterStartError FighterType FontType ImpactParticles InventoryItemType JumpError KeyboardKey ListBoxEntryType MalusReason MaterialType MoonType MouseButton PlanetType PlanTypeFilter PlayerStateType ProjectileShape RarityType RelationStatus SavedDesignType ScenarioType SectorChangeType ShipAvailability SoundType StatsBonuses TargetIndicatorVisuals TransformationFeature TurretAutoFireMode TurretSlotType WeaponAppearance WeaponCategory

This is the official documentation for the scripting API of Avorion. This documentation is automatically generated and not necessarily complete. Depending on the context in which functions exist, some documentation such as descriptions, return values or variable names or types may be missing.

Work in Progress. Documentation of Avorion Version: 2.5.8 a0d3f0b5b065